/*  : ̻
 * 糯 : 2003 4 3
 * ģ : 2003 4 3
 */
#include <sys/msg.h>
#include <sys/time.h>
#include <fcntl.h>
#include <stdio.h>
#include "Common.h"

int main( int argc, char *argv[] )
{
	int		idMsgQueue;
	int		nEndFlag = 0;
	int		nRtn;
	int		fdLogFile;
	char	caDate[9], caTime[7], caPrevDate[9];
	char	caFileName[20];
	char	caBuff[1025];
	char	caPutBuff[1500];

	if ( argc != 2 )
	{
		puts( "Format error" );
		return -1;
	}

	CurrentDate( caPrevDate );
	CurrentDate( caDate );

	sprintf( caFileName, "%s%s.log", argv[1], caDate );

	fdLogFile = open( caFileName, O_CREAT | O_RDWR | O_APPEND | O_SYNC, 0644 );
	if ( fdLogFile == -1 )
	{
		puts( "Log File Open Error!" );
		return -1;
	}

	idMsgQueue = msgget( (key_t)0x239, 0644 | IPC_CREAT );
	
	while ( !nEndFlag )
	{
		bzero( caBuff, sizeof( caBuff ) );
		nRtn = msgrcv( idMsgQueue, caBuff, sizeof( caBuff )-1, 0, MSG_NOERROR );
		if ( nRtn < 0 )
		{
			strcpy( caPrevDate, caDate );
			CurrentDate( caDate );
			if ( strcmp( caPrevDate, caDate ) != 0 )
			{
				close( fdLogFile );
				sprintf( caFileName, "%s%s.log", argv[1], caDate );
				fdLogFile = open( caFileName, 
								O_CREAT | O_RDWR | O_APPEND | O_SYNC, 0644 );

				if ( fdLogFile == -1 )
				{
					puts( "Log File Open Error!" );
					return -1;
				}
			}
			CurrentTime( caTime );
			sprintf( caPutBuff, "[%s][%s] : %s\n", 
											caDate, caTime, "msgrcv Error" );
			write( fdLogFile, caPutBuff, strlen( caPutBuff ) );
			continue;
		}
		strcpy( caPrevDate, caDate );
		CurrentDate( caDate );
		if ( strcmp( caPrevDate, caDate ) != 0 )
		{
			close( fdLogFile );
			sprintf( caFileName, "%s%s.log", argv[1], caDate );
			fdLogFile = open( caFileName, 
							O_CREAT | O_RDWR | O_APPEND | O_SYNC, 0644 );

			if ( fdLogFile == -1 )
			{
				puts( "Log File Open Error!" );
				return -1;
			}
		}
		CurrentTime( caTime );
		sprintf( caPutBuff, "[%s][%s] : %s\n", caDate, caTime, caBuff );
		write( fdLogFile, caPutBuff, strlen( caPutBuff ) );
	}
	close( fdLogFile );
	return 0;
}
